<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onSearch', 'plgSearchDartscores' );
$mainframe->registerEvent( 'onSearchAreas', 'plgSearchDartscoresAreas' );

//Load the Plugin language file out of the administration
JPlugin::loadLanguage( 'plg_search_Dartscores', JPATH_ADMINISTRATOR);

/**
 * @return array An array of search areas
 */
function &plgSearchDartscoresAreas() {
	static $areas = array(
	'wedstrijden' => 'WEDSTRIJDEN',
	'personen' => 'PERSONEN',
	'klassen' => 'KLASSEN'
	);
	return $areas;
}

/**
 * Categories Search method
 *
 * The sql must return the following fields that are
 * used in a common display routine: href, title, section, created, text,
 * browsernav
 * @param string Target search string
 * @param string mathcing option, exact|any|all
 * @param string ordering option, newest|oldest|popular|alpha|category
 * @param mixed An array if restricted to areas, null if search all
 */
function plgSearchDartscores( $text, $phrase='', $ordering='', $areas=null )
{
	$db		=& JFactory::getDBO();
	$user	=& JFactory::getUser();
	
	require_once(JPATH_SITE.DS.'components'.DS.'com_dartscores'.DS.'router.php');

	if (is_array( $areas )) {
		if (!array_intersect( $areas, array_keys( plgSearchDartscoresAreas() ) )) {
			return array();
		}
	} else {
		$areas = array_keys( plgSearchDartscoresAreas() );
	}

	// load plugin params info
	$plugin =& JPluginHelper::getPlugin('search', 'Dartscores');
	$pluginParams = new JParameter( $plugin->params );

	$limit = $pluginParams->def( 'search_limit', 50 );

	$text = trim( $text );
	if ( $text == '' ) {
		return array();
	}

	$searchDartscores = $db->Quote(JText::_( 'DARTSCORES' ));
	$searchDartscoresWedstrijden = $db->Quote(JText::_( 'WEDSTRIJDEN' ));
	$searchDartscoresPersonen = $db->Quote(JText::_( 'PERSONEN' ));
	$searchDartscoresKlassen = $db->Quote(JText::_( 'KLASSEN' ));

	$rows = array();

	if(in_array('wedstrijden', $areas)) {

		switch ($phrase) {
			case 'exact':
				$search 		= $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'LOWER(a.naam) LIKE '.$search;
				$wheres2[] 	= 'LOWER(a.beschrijving) LIKE '.$search;
				$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
				break;

			case 'all':
			case 'any':
			default:
				$words = explode( ' ', $text );
				$wheres = array();
				foreach ($words as $word) {
					$word 		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'LOWER(a.naam) LIKE '.$word;
					$wheres2[] 	= 'LOWER(a.beschrijving) LIKE '.$word;
					$wheres[] 	= implode( ' OR ', $wheres2 );
				}
				$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}
		
		$order = 'a.naam';

		$query = 'SELECT a.naam AS title,'
		. ' a.beschrijving AS text,'
		. ' a.begindatum AS created,'
		. ' a.einddatum,'
		. ' a.rondes,'
		. ' a.pijlronde,'
		. ' "2" AS browsernav,'
		. ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, '
		. ' CONCAT_WS( " / ", '. $searchDartscores .', '. $searchDartscoresWedstrijden .' , a.naam ) AS section'
		. ' FROM #__dartscores_wedstrijd AS a'
		. ' WHERE ( '.$where.' )'
		. ' AND a.published = 1'
		. ' ORDER BY '. $order
		;
		$db->setQuery( $query, 0, $limit );
		$list = $db->loadObjectList();

		foreach($list as $key => $row) {
			$list[$key]->href = JRoute::_('index.php?option=com_dartscores&view=wedstrijd&id='.$row->slug);
			$list[$key]->text = str_replace('[NAME]',$row->title,$row->text);
			$list[$key]->text = str_replace('[STARTDATE]',JHTML::_('date', $row->created, JText::_('DATE_FORMAT_LC1')),$row->text);
			$list[$key]->text = str_replace('[ENDDATE]',JHTML::_('date', $row->einddatum, JText::_('DATE_FORMAT_LC1')),$row->text);
			$list[$key]->text = str_replace('[ROUNDS]',$row->rondes,$row->text);
			$list[$key]->text = str_replace('[SHOTROUND]',$row->pijlronde,$row->text);
		}

		$rows[] = $list;
	}

	if(in_array('personen', $areas)) {

		switch ($phrase) {
			case 'exact':
				$search 		= $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'LOWER(a.naam) LIKE '.$search;
				$wheres2[] 	= 'LOWER(a.beschrijving) LIKE '.$search;
				$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
				break;

			case 'all':
			case 'any':
			default:
				$words = explode( ' ', $text );
				$wheres = array();
				foreach ($words as $word) {
					$word 		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'LOWER(a.naam) LIKE '.$word;
					$wheres2[] 	= 'LOWER(a.beschrijving) LIKE '.$word;
					$wheres[] 	= implode( ' OR ', $wheres2 );
				}
				$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}
		
		$order = 'a.naam';

		$query = 'SELECT a.naam AS title,'
		. ' a.beschrijving AS text,'
		. ' "2" AS browsernav,'
		. ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, '
		. ' CONCAT_WS( " / ", '. $searchDartscores .', '. $searchDartscoresPersonen .' ,  a.naam ) AS section'
		. ' FROM #__dartscores_persoon AS a'
		. ' WHERE ( '.$where.' )'
		. ' AND a.published = 1'
		. ' ORDER BY '. $order
		;
		$db->setQuery( $query, 0, $limit );
		$list = $db->loadObjectList();

		foreach($list as $key => $row) {
			$list[$key]->href = JRoute::_('index.php?option=com_dartscores&view=persoon&id='.$row->slug);
			$list[$key]->text = str_replace('[NAME]',$row->title,$list[$key]->text);
		}

		$rows[] = $list;
	}

	if(in_array('klassen', $areas)) {

		switch ($phrase) {
			case 'exact':
				$search 		= $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'LOWER(a.naam) LIKE '.$search;
				$wheres2[] 	= 'LOWER(a.beschrijving) LIKE '.$search;
				$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
				break;

			case 'all':
			case 'any':
			default:
				$words = explode( ' ', $text );
				$wheres = array();
				foreach ($words as $word) {
					$word 		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'LOWER(a.naam) LIKE '.$word;
					$wheres2[] 	= 'LOWER(a.beschrijving) LIKE '.$word;
					$wheres[] 	= implode( ' OR ', $wheres2 );
				}
				$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
				break;
		}
		
		$order = 'a.naam';

		$query = 'SELECT a.naam AS title,'
		. ' a.beschrijving AS text,'
		. ' "2" AS browsernav,'
		. ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, '
		. ' CONCAT_WS( " / ", '. $searchDartscores .',  '. $searchDartscoresKlassen .' , a.naam ) AS section'
		. ' FROM #__dartscores_klasse AS a'
		. ' WHERE ( '.$where.' )'
		. ' AND a.published = 1'
		. ' ORDER BY '. $order
		;
		$db->setQuery( $query, 0, $limit );
		$list = $db->loadObjectList();

		foreach($list as $key => $row) {
			$list[$key]->href = JRoute::_('index.php?option=com_dartscores&view=klasse&id='.$row->slug);
			$list[$key]->text = str_replace('[NAME]',$row->title,$list[$key]->text);
		}

		$rows[] = $list;
	}
	
	$count = count( $rows );
	if ( $count > 1 ) {
		switch ( $count ) {
			case 2:
				$results = array_merge( (array) $rows[0], (array) $rows[1] );
				break;

			case 3:
				$results = array_merge( (array) $rows[0], (array) $rows[1], (array) $rows[2] );
				break;

			case 4:
			default:
				$results = array_merge( (array) $rows[0], (array) $rows[1], (array) $rows[2], (array) $rows[3] );
				break;
		}

		return $results;
	} else if ( $count == 1 ) {
		return $rows[0];
	}
}
?>